import java.awt.Point;

public class BulletTracking {
    // 子弹类
    static class Bullet {
        private Point position; // 子弹位置
        private int trackingRange; // 子弹追踪范围半径

        public Bullet(int x, int y, int trackingRange) {
            this.position = new Point(x, y);
            this.trackingRange = trackingRange;
        }

        public Point getPosition() {
            return position;
        }

        public int getTrackingRange() {
            return trackingRange;
        }
    }

    // 目标类
    static class Target {
        private Point position; // 目标位置

        public Target(int x, int y) {
            this.position = new Point(x, y);
        }

        public Point getPosition() {
            return position;
        }
    }

    // 判断子弹是否在追踪范围内
    public static boolean isTargetInTrackingRange(Bullet bullet, Target target) {
        int dx = bullet.getPosition().x - target.getPosition().x;
        int dy = bullet.getPosition().y - target.getPosition().y;
        double distance = Math.sqrt(dx * dx + dy * dy); // 计算子弹与目标之间的距离
        return distance <= bullet.getTrackingRange(); // 判断是否在追踪范围内
    }

    public static void main(String[] args) {
        // 创建一个子弹对象，位置为(0, 0)，追踪范围半径为10
        Bullet bullet = new Bullet(0, 0, 10);
        // 创建一个目标对象，位置为(5, 5)
        Target target = new Target(5, 5);

        // 判断目标是否在子弹的追踪范围内
        if (isTargetInTrackingRange(bullet, target)) {
            System.out.println("目标在子弹的追踪范围内！");
        } else {
            System.out.println("目标不在子弹的追踪范围内！");
        }
    }
}