import java.awt.geom.Point2D;

// 枪械类
class Gun {
    private String model; // 枪械型号
    private int ammo; // 当前弹药数量
    private int range; // 枪械射程（超大范围）

    public Gun(String model, int ammo, int range) {
        this.model = model;
        this.ammo = ammo;
        this.range = range;
    }

    public void shoot(Point2D targetPosition) {
        if (ammo > 0) {
            ammo--;
            System.out.println("Bang! Target hit at: " + targetPosition);
        } else {
            System.out.println("Out of ammo!");
        }
    }

    public void reload(int ammo) {
        this.ammo += ammo;
        System.out.println("Reloaded " + ammo + " rounds.");
    }

    public int getRange() {
        return range;
    }
}

// 角色类
class Character {
    private String name; // 角色名称
    private int health; // 角色生命值
    private Gun gun; // 角色持有的枪械

    public Character(String name, int health, Gun gun) {
        this.name = name;
        this.health = health;
        this.gun = gun;
    }

    public void shoot(Point2D targetPosition) {
        if (gun.getRange() >= targetPosition.distance(0, 0)) { // 假设角色在原点(0,0)
            gun.shoot(targetPosition);
        } else {
            System.out.println("Target out of range!");
        }
    }

    public void reload(int ammo) {
        gun.reload(ammo);
    }
}

// 主程序
public class SuperRangeGun {
    public static void main(String[] args) {
        // 创建枪械对象，射程为1000单位
        Gun gun = new Gun("Super Range Gun", 10, 1000);
        // 创建角色对象
        Character character = new Character("John", 100, gun);

        // 创建目标位置
        Point2D targetPosition = new Point2D.Double(500, 500); // 目标距离原点500单位

        // 尝试射击目标
        character.shoot(targetPosition); // 目标在射程内，射击成功

        // 创建一个超出射程的目标位置
        Point2D outOfRangeTarget = new Point2D.Double(1500, 1500); // 目标距离原点1500单位

        // 尝试射击超出射程的目标
        character.shoot(outOfRangeTarget); // 目标超出射程，射击失败
    }
}