import java.util.Random;

// 枪械类
class Gun {
    private String model; // 枪械型号
    private int baseDamage; // 基础伤害
    private int damageDecayStart; // 伤害衰减开始距离
    private int damageDecayEnd; // 伤害衰减结束距离
    private double damageDecayRate; // 伤害衰减率

    public Gun(String model, int baseDamage, int damageDecayStart, int damageDecayEnd, double damageDecayRate) {
        this.model = model;
        this.baseDamage = baseDamage;
        this.damageDecayStart = damageDecayStart;
        this.damageDecayEnd = damageDecayEnd;
        this.damageDecayRate = damageDecayRate;
    }

    // 计算伤害
    public int calculateDamage(double distance) {
        if (distance <= damageDecayStart) {
            return baseDamage; // 在衰减距离之前，伤害不变
        } else if (distance >= damageDecayEnd) {
            return (int) (baseDamage * Math.pow(damageDecayRate, (damageDecayEnd - damageDecayStart))); // 超出衰减范围，固定衰减
        } else {
            return (int) (baseDamage * Math.pow(damageDecayRate, (distance - damageDecayStart))); // 在衰减范围内，按比例衰减
        }
    }

    public void enhanceDamage() {
        // 增强伤害，例如增加基础伤害和调整衰减率
        baseDamage += 5; // 增加基础伤害
        damageDecayRate *= 0.95; // 减小衰减率，使伤害衰减得更慢
        System.out.println("M416伤害增强完成！");
        System.out.println("新的基础伤害: " + baseDamage);
        System.out.println("新的伤害衰减率: " + damageDecayRate);
    }
}

// 主程序
public class M416Enhancement {
    public static void main(String[] args) {
        // 创建M416枪械对象
        Gun m416 = new Gun("M416", 40, 50, 350, 0.95); // 基础伤害40，伤害衰减开始距离50米，结束距离350米，衰减率0.95

        // 增强M416伤害
        m416.enhanceDamage();

        // 模拟射击不同距离的目标
        Random random = new Random();
        for (int i = 0; i < 5; i++) {
            double distance = random.nextDouble() * 400; // 随机生成0到400米之间的距离
            int damage = m416.calculateDamage(distance);
            System.out.println("射击距离: " + distance + "米，造成的伤害: " + damage);
        }
    }
}