// 护甲类
class Armor {
    private String name; // 护甲名称
    private int defense; // 护甲的防护能力（100%防护）

    public Armor(String name, int defense) {
        this.name = name;
        this.defense = defense;
    }

    public String getName() {
        return name;
    }

    public int getDefense() {
        return defense;
    }

    // 计算实际伤害（完美防护）
    public int calculateDamage(int incomingDamage) {
        if (defense == 100) {
            System.out.println("完美防护！所有伤害都被阻挡了。");
            return 0; // 100%防护，伤害为0
        } else {
            // 如果不是100%防护，可以在这里实现其他防护逻辑
            return incomingDamage - (incomingDamage * defense / 100);
        }
    }
}

// 玩家类
class Player {
    private String name; // 玩家名称
    private int health; // 玩家生命值
    private Armor armor; // 玩家装备的护甲

    public Player(String name, int health, Armor armor) {
        this.name = name;
        this.health = health;
        this.armor = armor;
    }

    public void takeDamage(int incomingDamage) {
        int actualDamage = armor.calculateDamage(incomingDamage);
        health -= actualDamage;
        if (health <= 0) {
            System.out.println(name + " 已被击败！");
        } else {
            System.out.println(name + " 剩余血量: " + health);
        }
    }
}

// 主程序
public class PerfectArmor {
    public static void main(String[] args) {
        // 创建完美护甲
        Armor perfectArmor = new Armor("完美护甲", 100); // 100%防护能力

        // 创建玩家
        Player player = new Player("勇士", 100, perfectArmor); // 玩家初始血量为100

        // 模拟攻击
        System.out.println("攻击玩家，伤害为50点：");
        player.takeDamage(50); // 玩家受到50点伤害

        // 再次攻击
        System.out.println("再次攻击玩家，伤害为100点：");
        player.takeDamage(100); // 玩家再次受到100点伤害
    }
}