import java.util.Random;

// 枪械类
class Gun {
    private String model; // 枪械型号
    private int range; // 枪械射程
    private double accuracy; // 枪械精度（命中概率）

    public Gun(String model, int range, double accuracy) {
        this.model = model;
        this.range = range;
        this.accuracy = accuracy;
    }

    // 模拟射击
    public boolean shoot(double distance) {
        if (distance > range) {
            System.out.println("目标超出射程！");
            return false;
        }
        Random random = new Random();
        double hitProbability = random.nextDouble();
        if (hitProbability <= accuracy) {
            System.out.println("命中目标！");
            return true;
        } else {
            System.out.println("未命中目标！");
            return false;
        }
    }
}

// 目标类
class Target {
    private double x; // 目标X坐标
    private double y; // 目标Y坐标

    public Target(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public double distanceTo(double startX, double startY) {
        return Math.sqrt(Math.pow(x - startX, 2) + Math.pow(y - startY, 2));
    }
}

// 主程序
public class SuperRangeGun {
    public static void main(String[] args) {
        // 创建枪械对象
        Gun gun = new Gun("Super Range Gun", 1000, 0.88); // 射程1000单位，命中概率88%

        // 创建目标对象
        Target target = new Target(800, 600); // 目标位置(800, 600)

        // 计算射击距离
        double distance = target.distanceTo(0, 0); // 假设枪械在原点(0,0)
        System.out.println("射击距离: " + distance);

        // 模拟射击
        gun.shoot(distance);
    }
}