import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.LinkedList;
import java.util.Queue;

public class SmoothMouseMovement extends JFrame {
    private final int SMOOTHING_FACTOR = 5; // 平滑因子，值越大越平滑
    private Queue<Point> mousePoints = new LinkedList<>();

    public SmoothMouseMovement() {
        setTitle("Smooth Mouse Movement");
        setSize(800, 600);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLocationRelativeTo(null);

        addMouseListener(new MouseAdapter() {
            @Override
            public void mouseMoved(MouseEvent e) {
                Point newPoint = e.getPoint();
                mousePoints.add(newPoint);

                // 保持队列长度为SMOOTHING_FACTOR
                if (mousePoints.size() > SMOOTHING_FACTOR) {
                    mousePoints.poll();
                }

                // 计算平滑后的鼠标位置
                Point smoothedPoint = calculateSmoothedPoint();
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.NW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SE_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.SW_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.OPEN_HAND_CURSOR));
                setCursor(new Cursor(Cursor.CLOSED_HAND_CURSOR));
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                setCursor(new Cursor(Cursor.MOVE_CURSOR));
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                setCursor(new Cursor(Cursor.TEXT_CURSOR));
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
                setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
                setCursor(new Cursor(Cursor.E