import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;
import javafx.util.Duration;

public class GrowingHead extends Application {
    @Override
    public void start(Stage primaryStage) {
        // 创建一个Pane作为根节点
        Pane root = new Pane();

        // 创建一个圆形代表头部
        Circle head = new Circle(100, 100, 50); // x, y, radius
        head.setFill(Color.BLUE); // 设置颜色

        // 将圆形添加到根节点
        root.getChildren().add(head);

        // 创建一个场景
        Scene scene = new Scene(root, 400, 400);

        // 设置舞台
        primaryStage.setTitle("Growing Head");
        primaryStage.setScene(scene);
        primaryStage.show();

        // 创建一个时间线来实现动画效果
        Timeline timeline = new Timeline(new KeyFrame(Duration.millis(50), event -> {
            // 每次更新时，增加头部的半径
            head.setRadius(head.getRadius() + 1);

            // 如果头部变得太大，可以停止动画
            if (head.getRadius() > 200) {
                timeline.stop();
            }
        }));

        // 设置动画的循环次数
        timeline.setCycleCount(Timeline.INDEFINITE);

        // 启动动画
        timeline.play();
    }

    public static void main(String[] args) {
        launch(args);
    }
}