package com.tencent.tmgp.pubgmhd;

import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        // 创建枪械列表
        Firearms[] firearms = {
            new Firearms("M416"),
            new Firearms("AUG"),
            new Firearms("AKM"),
            new Firearms("M762"),
            new Firearms("SCAR-L"),
            new Firearms("GROZA"),
            new Firearms("UMP45"),
            new Firearms("Uzi"),
            new Firearms("Vector"),
            new Firearms("P90"),
            new Firearms("Mk14"),
            new Firearms("M249"),
            new Firearms("MG3"),
            new Firearms("PKM"),
            new Firearms("DP28"),
            new Firearms("S12k")
        };

        // 用户交互
        Scanner scanner = new Scanner(System.in);
        System.out.println("请选择要启用锁头功能的枪械编号（0-15）：");
        for (int i = 0; i < firearms.length; i++) {
            System.out.println(i + ": " + firearms[i].getName());
        }

        int choice;
        try {
            choice = scanner.nextInt();
            if (choice >= 0 && choice < firearms.length) {
                firearms[choice].applyAimBotLockHead();
            } else {
                System.out.println("无效的编号！");
            }
        } catch (Exception e) {
            System.out.println("输入错误！");
        } finally {
            scanner.close();
        }
    }
}

class Firearms {
    private String name;
    private double damage;
    private double fireRate;

    // 构造函数
    public Firearms(String name) {
        this.name = name;
        // 假设的伤害值和射速
        this.damage = Math.random() * 100; // 随机伤害值
        this.fireRate = Math.random() * 10; // 随机射速
    }

    // 获取枪械名称
    public String getName() {
        return name;
    }

    // 应用锁头功能
    public void applyAimBotLockHead() {
        System.out.println(name + " 已启用锁头功能！");
        System.out.println("伤害值: " + damage);
        System.out.println("射速: " + fireRate + " 发/秒");
    }
}
