package com.tencent.tmgp.pubgmhd;

import java.util.Scanner;

public class BulletTrackingSystem {
    public static void main(String[] args) {
        // 模拟游戏中的枪械和目标
        Weapon[] weapons = {
            new Weapon("M416"),
            new Weapon("AUG"),
            new Weapon("AKM"),
            new Weapon("M762"),
            new Weapon("SCAR-L"),
            new Weapon("GROZA"),
            new Weapon("UMP45"),
            new Weapon("Uzi"),
            new Weapon("Vector"),
            new Weapon("P90"),
            new Weapon("Mk14"),
            new Weapon("M249"),
            new Weapon("MG3"),
            new Weapon("PKM"),
            new Weapon("DP28"),
            new Weapon("S12k")
        };

        // 用户交互
        Scanner scanner = new Scanner(System.in);
        System.out.println("请选择要启用子弹追踪功能的枪械编号（0-15）：");
        for (int i = 0; i < weapons.length; i++) {
            System.out.println(i + ": " + weapons[i].getName());
        }

        int choice;
        try {
            choice = scanner.nextInt();
            if (choice >= 0 && choice < weapons.length) {
                weapons[choice].enableBulletTracking();
            } else {
                System.out.println("无效的编号！");
            }
        } catch (Exception e) {
            System.out.println("输入错误！");
        } finally {
            scanner.close();
        }
    }
}

class Weapon {
    private String name;
    private double damage;
    private double fireRate;
    private double trackingAccuracy; // 追踪精度

    // 构造函数
    public Weapon(String name) {
        this.name = name;
        this.damage = Math.random() * 100; // 随机伤害值
        this.fireRate = Math.random() * 10; // 随机射速
        this.trackingAccuracy = Math.random() * 100; // 随机追踪精度
    }

    // 获取枪械名称
    public String getName() {
        return name;
    }

    // 启用子弹追踪功能
    public void enableBulletTracking() {
        System.out.println(name + " 已启用子弹追踪功能！");
        System.out.println("伤害值: " + damage);
        System.out.println("射速: " + fireRate + " 发/秒");
        System.out.println("追踪精度: " + trackingAccuracy + "%");
        System.out.println("目标锁定区域：头部");
        System.out.println("追踪范围：360°×360°");
        System.out.println("追踪强度：MAX");
        System.out.println("命中率：MAX");
        System.out.println("追踪效果：子弹自动追踪并命中目标头部");
    }
}
