package com.tencent.tmgp.pubgmhd;

import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        // 创建枪械列表
        Firearms[] firearms = {
            new Firearms("M416", 35, 10, 90),
            new Firearms("AUG", 38, 9, 92),
            new Firearms("AKM", 42, 8, 88),
            new Firearms("M762", 40, 9, 89),
            new Firearms("SCAR-L", 36, 10, 91),
            new Firearms("GROZA", 41, 8, 93),
            new Firearms("UMP45", 30, 12, 85),
            new Firearms("Uzi", 28, 15, 80),
            new Firearms("Vector", 32, 13, 86),
            new Firearms("P90", 34, 11, 87),
            new Firearms("Mk14", 45, 7, 95),
            new Firearms("M249", 48, 6, 96),
            new Firearms("MG3", 50, 5, 97),
            new Firearms("PKM", 52, 4, 98),
            new Firearms("DP28", 55, 3, 99),
            new Firearms("S12k", 38, 10, 88)
        };

        // 用户交互
        Scanner scanner = new Scanner(System.in);
        System.out.println("请选择要启用锁头功能的枪械编号（0-15）：");
        for (int i = 0; i < firearms.length; i++) {
            System.out.println(i + ": " + firearms[i].getName());
        }

        int choice;
        try {
            choice = scanner.nextInt();
            if (choice >= 0 && choice < firearms.length) {
                firearms[choice].applyAimBotLockHead();
            } else {
                System.out.println("无效的编号！");
            }
        } catch (Exception e) {
            System.out.println("输入错误！");
        } finally {
            scanner.close();
        }
    }
}

class Firearms {
    private String name; // 枪械名称
    private double damage; // 伤害值
    private double fireRate; // 射速
    private double accuracy; // 精度
    private boolean aimBotLockHeadEnabled; // 是否启用锁头功能

    // 构造函数
    public Firearms(String name, double damage, double fireRate, double accuracy) {
        this.name = name;
        this.damage = damage;
        this.fireRate = fireRate;
        this.accuracy = accuracy;
        this.aimBotLockHeadEnabled = false;
    }

    // 获取枪械名称
    public String getName() {
        return name;
    }

    // 启用锁头功能
    public void applyAimBotLockHead() {
        aimBotLockHeadEnabled = true;
        System.out.println(name + " 已启用锁头功能！");
        System.out.println("伤害值: " + damage);
        System.out.println("射速: " + fireRate + " 发/秒");
        System.out.println("精度: " + accuracy + "%");
        System.out.println("锁头功能已启用，目标锁定区域：头部");
    }
}
