package com.tencent.tmgp.pubgmhd;

import java.io.IOException;

public class Main {
    public static void main(String[] args) {
        try {
            // Load configuration from file
            Config config = Config.loadConfig("config.json");

            // Process GunBulletHitRangeTrackingHead
            GunBulletHitRangeTrackingHead gunConfig = config.getGunBulletHitRangeTrackingHead();
            System.out.println("Character Movement Bullet Tracking Head: " + gunConfig.getCharacterMovementBulletTrackingHead());
            System.out.println("Strength: " + gunConfig.getStrength());
            System.out.println("Power: " + gunConfig.getPower());
            System.out.println("Intensity: " + gunConfig.getIntensity());
            System.out.println("Bullet Tracking Head: " + gunConfig.getBulletTrackingHead());

            // Process FireEvent
            FireEvent fireEvent = config.getFireEvent();
            System.out.println("Fire Event Trigger: " + fireEvent.getTrigger());

            // Process MovementEvent
            MovementEvent movementEvent = config.getMovementEvent();
            System.out.println("Movement Event Trigger: " + movementEvent.getTrigger());
            System.out.println("Movement Event Action: " + movementEvent.getAction());

            // Process NoZoom
            NoZoom noZoom = config.getNoZoom();
            System.out.println("No Zoom Speed: " + noZoom.getSpeed());
            System.out.println("No Zoom Strength: " + noZoom.getStrength());
            System.out.println("No Zoom Power: " + noZoom.getPower());
            System.out.println("No Zoom Intensity: " + noZoom.getIntensity());
            System.out.println("No Zoom Bullet Tracking Head: " + noZoom.getBulletTrackingHead());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}