import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

class Vector2 {
    double x;
    double y;

    Vector2(double x, double y) {
        this.x = x;
        this.y = y;
    }

    @Override
    public String toString() {
        return String.format("(%.2f, %.2f)", x, y);
    }
}

class Player {
    Vector2 position;

    Player(Vector2 position) {
        this.position = position;
    }
}

class Enemy {
    Vector2 position;

    Enemy(Vector2 position) {
        this.position = position;
    }
}

public class Main {
    public static Vector2 aimAtEnemy(Player player, Enemy enemy, double multiplier) {
        double aimX = player.position.x + (enemy.position.x - player.position.x) * multiplier;
        double aimY = player.position.y + (enemy.position.y - player.position.y) * multiplier;

        return new Vector2(aimX, aimY);
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // 输入玩家位置
        System.out.print("Enter player position (x y): ");
        double playerX = scanner.nextDouble();
        double playerY = scanner.nextDouble();
        Player player = new Player(new Vector2(playerX, playerY));

        // 输入敌人位置
        List<Enemy> enemies = new ArrayList<>();
        System.out.print("Enter number of enemies: ");
        int numEnemies = scanner.nextInt();
        for (int i = 0; i < numEnemies; i++) {
            System.out.print("Enter enemy " + (i + 1) + " position (x y): ");
            double enemyX = scanner.nextDouble();
            double enemyY = scanner.nextDouble();
            enemies.add(new Enemy(new Vector2(enemyX, enemyY)));
        }

        // 输入瞄准倍率
        System.out.print("Enter aiming multiplier: ");
        double multiplier = scanner.nextDouble();

        // 计算瞄准点
        for (Enemy enemy : enemies) {
            Vector2 aimPosition = aimAtEnemy(player, enemy, multiplier);
            System.out.println("Aiming at enemy " + enemy.position + " with multiplier " + multiplier + ": " + aimPosition);
        }

        scanner.close();
    }
}