import java.util.Map;

public class Main {
    public static void main(String[] args) {
        try {
            UltraAdvancedBulletTrackingSystem system = ConfigLoader.loadConfig("config.json");

            System.out.println("Status: " + system.getStatus());
            System.out.println("Firearms: " + system.getFirearms());

            System.out.println("\nSystem Attributes:");
            Map<String, String> attributes = system.getSystemAttributes();
            for (Map.Entry<String, String> entry : attributes.entrySet()) {
                System.out.println(entry.getKey() + ": " + entry.getValue());
            }

            System.out.println("\nEnhanced Features:");
            Map<String, String> features = system.getEnhancedFeatures();
            for (Map.Entry<String, String> entry : features.entrySet()) {
                System.out.println(entry.getKey() + ": " + entry.getValue());
            }

            // 根据配置执行相应的功能逻辑
            // 示例：启用子弹追踪系统
            enableBulletTrackingSystem(system);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void enableBulletTrackingSystem(UltraAdvancedBulletTrackingSystem system) {
        System.out.println("\nEnabling Ultra-Advanced Bullet Tracking System...");
        System.out.println("Status: " + system.getStatus());
        System.out.println("Firearms: " + system.getFirearms());
        System.out.println("System is now in Enhanced Active Mode.");
    }
}