import java.util.Scanner;

public class GameSettings {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // 创建对象
        Player player = new Player();
        Weapon weapon = new Weapon();
        Armor armor = new Armor();
        Helmet helmet = new Helmet();
        Map map = new Map();
        PlayerType playerType = new PlayerType();
        GameMode gameMode = new GameMode();

        // 设置玩家属性
        System.out.println("Enter player damage (default: 999999): ");
        player.setDamage(scanner.nextInt());
        scanner.nextLine(); // 消耗换行符

        // 设置武器属性
        System.out.println("Enter weapon headshot damage (default: 999999): ");
        weapon.setHeadshotDamage(scanner.nextInt());
        scanner.nextLine();

        System.out.println("Enter weapon gun damage (default: 999999): ");
        weapon.setGunDamage(scanner.nextInt());
        scanner.nextLine();

        System.out.println("Enter weapon melee damage (default: 999999): ");
        weapon.setMeleeDamage(scanner.nextInt());
        scanner.nextLine();

        System.out.println("Enter weapon ranged damage (default: 999999): ");
        weapon.setRangedDamage(scanner.nextInt());
        scanner.nextLine();

        // 设置盔甲属性
        System.out.println("Enter armor penetration (default: 999999.9): ");
        armor.setPenetration(scanner.nextDouble());
        scanner.nextLine();

        // 设置头盔属性
        System.out.println("Enter helmet penetration (default: 999999.9): ");
        helmet.setPenetration(scanner.nextDouble());
        scanner.nextLine();

        System.out.println("Enter helmet headshot multiplier (default: 999999): ");
        helmet.setHeadshotMultiplier(scanner.nextInt());
        scanner.nextLine();

        // 设置地图属性
        System.out.println("Enter map name (default: Subway): ");
        map.setName(scanner.nextLine());

        System.out.println("Enter map type (default: All): ");
        map.setType(scanner.nextLine());

        // 设置玩家类型
        System.out.println("Enter player type name (default: All): ");
        playerType.setName(scanner.nextLine());

        // 设置游戏模式
        System.out.println("Enter game mode name (default: All): ");
        gameMode.setName(scanner.nextLine());

        // 输出所有设置
        System.out.println("\n--- Game Settings ---");
        System.out.println("Player Damage: " + player.getDamage());
        System.out.println("Weapon Headshot Damage: " + weapon.getHeadshotDamage());
        System.out.println("Weapon Gun Damage: " + weapon.getGunDamage());
        System.out.println("Weapon Melee Damage: " + weapon.getMeleeDamage());
        System.out.println("Weapon Ranged Damage: " + weapon.getRangedDamage());
        System.out.println("Armor Penetration: " + armor.getPenetration());
        System.out.println("Helmet Penetration: " + helmet.getPenetration());
        System.out.println("Helmet Headshot Multiplier: " + helmet.getHeadshotMultiplier());
        System.out.println("Map Name: " + map.getName());
        System.out.println("Map Type: " + map.getType());
        System.out.println("Player Type: " + playerType.getName());
        System.out.println("Game Mode: " + gameMode.getName());

        scanner.close();
    }
}

class Player {
    private int damage;

    public void setDamage(int damage) {
        this.damage = damage;
    }

    public int getDamage() {
        return damage;
    }
}

class Weapon {
    private int headshotDamage;
    private int gunDamage;
    private int meleeDamage;
    private int rangedDamage;

    public void setHeadshotDamage(int headshotDamage) {
        this.headshotDamage = headshotDamage;
    }

    public int getHeadshotDamage() {
        return headshotDamage;
    }

    public void setGunDamage(int gunDamage) {
        this.gunDamage = gunDamage;
    }

    public int getGunDamage() {
        return gunDamage;
    }

    public void setMeleeDamage(int meleeDamage) {
        this.meleeDamage = meleeDamage;
    }

    public int getMeleeDamage() {
        return meleeDamage;
    }

    public void setRangedDamage(int rangedDamage) {
        this.rangedDamage = rangedDamage;
    }

    public int getRangedDamage() {
        return rangedDamage;
    }
}

class Armor {
    private double penetration;

    public void setPenetration(double penetration) {
        this.penetration = penetration;
    }

    public double getPenetration() {
        return penetration;
    }
}

class Helmet {
    private double penetration;
    private int headshotMultiplier;

    public void setPenetration(double penetration) {
        this.penetration = penetration;
    }

    public double getPenetration() {
        return penetration;
    }

    public void setHeadshotMultiplier(int headshotMultiplier) {
        this.headshotMultiplier = headshotMultiplier;
    }

    public int getHeadshotMultiplier() {
        return headshotMultiplier;
    }
}

class Map {
    private String name;
    private String type;

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getType() {
        return type;
    }
}

class PlayerType {
    private String name;

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}

class GameMode {
    private String name;

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}