import java.io.*;
import java.util.Scanner;

public class GameConfig {
    private int playerDamage;
    private double playerJumpHeight;
    private int weaponHeadshotDamage;
    private int weaponGunDamage;
    private double weaponArmorPenetration;
    private int weaponMeleeDamage;
    private int weaponRangedDamage;
    private int helmetHighDamage;
    private int armorHighDamage;
    private double armorPenetration;
    private boolean subwayMapAllMaps;
    private boolean subwayWeaponAllWeapons;
    private boolean subwayArmorAllArmors;
    private boolean subwayHelmetAllHelmets;
    private boolean subwayPlayerAllPlayers;
    private boolean gameModeAllModes;

    // 默认构造函数
    public GameConfig() {
        playerDamage = 999999;
        playerJumpHeight = 999999.9;
        weaponHeadshotDamage = 999999;
        weaponGunDamage = 999999;
        weaponArmorPenetration = 999999.9;
        weaponMeleeDamage = 999999;
        weaponRangedDamage = 999999;
        helmetHighDamage = 999999;
        armorHighDamage = 999999;
        armorPenetration = 999999.9;
        subwayMapAllMaps = true;
        subwayWeaponAllWeapons = true;
        subwayArmorAllArmors = true;
        subwayHelmetAllHelmets = true;
        subwayPlayerAllPlayers = true;
        gameModeAllModes = true;
    }

    // 设置和获取方法
    public void setPlayerDamage(int playerDamage) {
        this.playerDamage = playerDamage;
    }

    public int getPlayerDamage() {
        return playerDamage;
    }

    public void setPlayerJumpHeight(double playerJumpHeight) {
        this.playerJumpHeight = playerJumpHeight;
    }

    public double getPlayerJumpHeight() {
        return playerJumpHeight;
    }

    public void setWeaponHeadshotDamage(int weaponHeadshotDamage) {
        this.weaponHeadshotDamage = weaponHeadshotDamage;
    }

    public int getWeaponHeadshotDamage() {
        return weaponHeadshotDamage;
    }

    public void setWeaponGunDamage(int weaponGunDamage) {
        this.weaponGunDamage = weaponGunDamage;
    }

    public int getWeaponGunDamage() {
        return weaponGunDamage;
    }

    public void setWeaponArmorPenetration(double weaponArmorPenetration) {
        this.weaponArmorPenetration = weaponArmorPenetration;
    }

    public double getWeaponArmorPenetration() {
        return weaponArmorPenetration;
    }

    public void setWeaponMeleeDamage(int weaponMeleeDamage) {
        this.weaponMeleeDamage = weaponMeleeDamage;
    }

    public int getWeaponMeleeDamage() {
        return weaponMeleeDamage;
    }

    public void setWeaponRangedDamage(int weaponRangedDamage) {
        this.weaponRangedDamage = weaponRangedDamage;
    }

    public int getWeaponRangedDamage() {
        return weaponRangedDamage;
    }

    public void setHelmetHighDamage(int helmetHighDamage) {
        this.helmetHighDamage = helmetHighDamage;
    }

    public int getHelmetHighDamage() {
        return helmetHighDamage;
    }

    public void setArmorHighDamage(int armorHighDamage) {
        this.armorHighDamage = armorHighDamage;
    }

    public int getArmorHighDamage() {
        return armorHighDamage;
    }

    public void setArmorPenetration(double armorPenetration) {
        this.armorPenetration = armorPenetration;
    }

    public double getArmorPenetration() {
        return armorPenetration;
    }

    public void setSubwayMapAllMaps(boolean subwayMapAllMaps) {
        this.subwayMapAllMaps = subwayMapAllMaps;
    }

    public boolean isSubwayMapAllMaps() {
        return subwayMapAllMaps;
    }

    public void setSubwayWeaponAllWeapons(boolean subwayWeaponAllWeapons) {
        this.subwayWeaponAllWeapons = subwayWeaponAllWeapons;
    }

    public boolean isSubwayWeaponAllWeapons() {
        return subwayWeaponAllWeapons;
    }

    public void setSubwayArmorAllArmors(boolean subwayArmorAllArmors) {
        this.subwayArmorAllArmors = subwayArmorAllArmors;
    }

    public boolean isSubwayArmorAllArmors() {
        return subwayArmorAllArmors;
    }

    public void setSubwayHelmetAllHelmets(boolean subwayHelmetAllHelmets) {
        this.subwayHelmetAllHelmets = subwayHelmetAllHelmets;
    }

    public boolean isSubwayHelmetAllHelmets() {
        return subwayHelmetAllHelmets;
    }

    public void setSubwayPlayerAllPlayers(boolean subwayPlayerAllPlayers) {
        this.subwayPlayerAllPlayers = subwayPlayerAllPlayers;
    }

    public boolean isSubwayPlayerAllPlayers() {
        return subwayPlayerAllPlayers;
    }

    public void setGameModeAllModes(boolean gameModeAllModes) {
        this.gameModeAllModes = gameModeAllModes;
    }

    public boolean isGameModeAllModes() {
        return gameModeAllModes;
    }

    // 保存配置到文件
    public void saveConfig(String filename) throws IOException {
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(filename))) {
            writer.write("Player {\n");
            writer.write("    damage = " + playerDamage + "\n");
            writer.write("    jump_height = " + playerJumpHeight + "\n");
            writer.write("}\n");
            writer.write("Weapon {\n");
            writer.write("    headshot_damage = " + weaponHeadshotDamage + "\n");
            writer.write("    gun_damage = " + weaponGunDamage + "\n");
            writer.write("    armor_penetration = " + weaponArmorPenetration + "\n");
            writer.write("    melee_damage = " + weaponMeleeDamage + "\n");
            writer.write("    ranged_damage = " + weaponRangedDamage + "\n");
            writer.write("}\n");
            writer.write("Helmet {\n");
            writer.write("    high_damage = " + helmetHighDamage + "\n");
            writer.write("}\n");
            writer.write("Armor {\n");
            writer.write("    high_damage = " + armorHighDamage + "\n");
            writer.write("    penetration = " + armorPenetration + "\n");
            writer.write("}\n");
            writer.write("SubwayMap {\n");
            writer.write("    all_maps = " + subwayMapAllMaps + "\n");
            writer.write("}\n");
            writer.write("SubwayWeapon {\n");
            writer.write("    all_weapons = " + subwayWeaponAllWeapons + "\n");
            writer.write("}\n");
            writer.write("SubwayArmor {\n");
            writer.write("    all_armors = " + subwayArmorAllArmors + "\n");
            writer.write("}\n");
            writer.write("SubwayHelmet {\n");
            writer.write("    all_helmets = " + subwayHelmetAllHelmets + "\n");
            writer.write("}\n");
            writer.write("SubwayPlayer {\n");
            writer.write("    all_players = " + subwayPlayerAllPlayers + "\n");
            writer.write("}\n");
            writer.write("GameMode {\n");
            writer.write("    all_modes = " + gameModeAllModes + "\n");
            writer.write("}\n");
        }
    }

    // 从文件加载配置
    public void loadConfig(String filename) throws IOException {
        try (BufferedReader reader = new BufferedReader(new FileReader(filename))) {
            String line;
            while ((line = reader.readLine()) != null) {
                line = line.trim();
                if (line.startsWith("damage")) {
                    playerDamage = Integer.parseInt(line.split("=")[1].trim());
                } else if (line.startsWith("jump_height")) {
                    playerJumpHeight = Double.parseDouble(line.split("=")[1].trim());
                } else if (line.startsWith("headshot_damage")) {
                    weaponHeadshotDamage = Integer.parseInt(line.split("=")[1].trim());
                } else if (line.startsWith("gun_damage")) {
                    weaponGunDamage = Integer.parseInt(line.split("=")[1].trim());
                } else if (line.startsWith("armor_penetration")) {
                    weaponArmorPenetration = Double.parseDouble(line.split("=")[1].trim());
                } else if (line.startsWith("melee_damage")) {
                    weaponMeleeDamage = Integer.parseInt(line.split("=")[1].trim());
                } else if (line.startsWith("ranged_damage")) {
                    weaponRangedDamage = Integer.parseInt(line.split("=")[1].trim());
                } else if (line.startsWith("high_damage")) {
                    if (line.contains("Helmet")) {
                        helmetHighDamage