import java.util.Random;

public class SuperHeadshotGame {
    public static void main(String[] args) {
        // 创建玩家和武器
        Player player = new Player("Player1");
        Weapon weapon = new Weapon("Super Headshot Rifle");

        // 设置超高概率爆头模式
        weapon.setSuperHeadshotMode(true);

        // 模拟射击
        for (int i = 0; i < 10; i++) {
            boolean isHeadshot = player.shoot(weapon);
            if (isHeadshot) {
                System.out.println("Shot " + (i + 1) + ": Headshot!");
            } else {
                System.out.println("Shot " + (i + 1) + ": Missed headshot.");
            }
        }
    }
}

class Player {
    private String name;

    public Player(String name) {
        this.name = name;
    }

    // 玩家射击方法
    public boolean shoot(Weapon weapon) {
        return weapon.shoot();
    }
}

class Weapon {
    private String name;
    private boolean superHeadshotMode;

    public Weapon(String name) {
        this.name = name;
        this.superHeadshotMode = false;
    }

    // 设置超高概率爆头模式
    public void setSuperHeadshotMode(boolean superHeadshotMode) {
        this.superHeadshotMode = superHeadshotMode;
    }

    // 武器射击方法
    public boolean shoot() {
        Random random = new Random();
        if (superHeadshotMode) {
            // 在超高概率爆头模式下，爆头概率大大提高
            return random.nextDouble() < 0.9; // 90% 的概率爆头
        } else {
            // 正常模式下，爆头概率较低
            return random.nextDouble() < 0.1; // 10% 的概率爆头
        }
    }
}