import java.util.Random;
import java.util.Scanner;

public class EnhancedHipFireGame {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        Player player = new Player();

        System.out.println("Welcome to the Enhanced Hip Fire Game!");
        System.out.println("Enter '1' to Hip Fire, '2' to Aim and Shoot, or '0' to Exit.");

        while (true) {
            System.out.print("Your choice: ");
            int choice = scanner.nextInt();

            if (choice == 0) {
                System.out.println("Exiting game. Goodbye!");
                break;
            } else if (choice == 1) {
                player.enhancedHipFire();
            } else if (choice == 2) {
                player.aimAndShoot();
            } else {
                System.out.println("Invalid choice. Please try again.");
            }
        }

        scanner.close();
    }
}

class Player {
    private int hipFireAccuracy = 50; // 50% base accuracy for hip fire
    private int aimAccuracy = 90; // 90% accuracy for aimed shots
    private int enhancedAccuracyBonus = 20; // 20% bonus accuracy when enhanced
    private int enhancedDamageBonus = 5; // 5 extra damage when enhanced
    private int baseDamage = 10; // Base damage per shot

    public void enhancedHipFire() {
        System.out.println("Enhanced Hip Firing...");
        int accuracy = hipFireAccuracy + enhancedAccuracyBonus;
        int damage = baseDamage + enhancedDamageBonus;

        if (new Random().nextInt(100) < accuracy) {
            System.out.println("Hit! Damage dealt: " + damage);
        } else {
            System.out.println("Missed!");
        }
    }

    public void aimAndShoot() {
        System.out.println("Aiming and Shooting...");
        if (new Random().nextInt(100) < aimAccuracy) {
            System.out.println("Hit! Damage dealt: " + baseDamage);
        } else {
            System.out.println("Missed!");
        }
    }
}