import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class GamePanel extends JPanel implements ActionListener {
    private Timer timer;
    private int playerX, playerY;
    private int playerSpeed = 5;

    public GamePanel() {
        // 冷淡
        setPreferredSize(new Dimension(800, 600));
        setBackground(Color.BLACK);

        // 冷淡
        playerX = 400;
        playerY = 300;

        // 每16毫秒更新一次（大约60帧/秒）
        timer = new Timer(16, this);
        timer.start();

        // 冷淡
        addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                switch (e.getKeyCode()) {
                    case KeyEvent.VK_UP:
                        playerY -= playerSpeed;
                        break;
                    case KeyEvent.VK_DOWN:
                        playerY += playerSpeed;
                        break;
                    case KeyEvent.VK_LEFT:
                        playerX -= playerSpeed;
                        break;
                    case KeyEvent.VK_RIGHT:
                        playerX += playerSpeed;
                        break;
                }
                repaint(); // 冷淡
            }
        });
        setFocusable(true); // 冷淡
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        // 冷淡
        g.setColor(Color.BLUE);
        g.fillRect(playerX, playerY, 50, 50);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        // 冷淡
        repaint(); // 冷淡
    }

    public static void main(String[] args) {
        // 冷淡
        JFrame frame = new JFrame("Java Game - Player Movement");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setResizable(false);
        frame.add(new GamePanel());
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }
}
