-- modules/no_recoil.lua
local utils = require("utils")
local config = utils.load_config("config.lua")

function no_recoil()
    local bullet_speed = config.no_recoil.bullet_speed
    local gun_shake = config.no_recoil.gun_shake
    local follow_distance = config.no_recoil.follow_distance

    function follow_enemy()
        local target_pos = get_target_position()
        local player_pos = get_player_position()
        local distance = math.sqrt((target_pos.x - player_pos.x) ^ 2 + (target_pos.y - player_pos.y) ^ 2)

        if distance < follow_distance then
            set_player_position(target_pos.x, target_pos.y)
            start_gun_shake(gun_shake)
        end
    end

    follow_enemy()
    set_bullet_speed(bullet_speed)
end

return no_recoil