<?php

class Position {
    public $x;
    public $y;

    public function __construct($x, $y) {
        $this->x = $x;
        $this->y = $y;
    }
}

class GameObject {
    public $name;
    public $position;

    public function __construct($name, Position $position) {
        $this->name = $name;
        $this->position = $position;
    }
}

function isWithinRange(GameObject $object1, GameObject $object2, $range) {
    // 计算两个对象之间的距离
    $distance = sqrt(pow($object2->position->x - $object1->position->x, 2) +
                     pow($object2->position->y - $object1->position->y, 2));
    
    // 判断距离是否在范围内
    return $distance <= $range;
}

// 创建两个对象
$player = new GameObject("Player", new Position(10, 20));
$enemy = new GameObject("Enemy", new Position(15, 25));

// 设置范围
$range = 10;

// 检测是否在范围内
if (isWithinRange($player, $enemy, $range)) {
    echo $player->name . " is within range of " . $enemy->name . "\n";
} else {
    echo $player->name . " is NOT within range of " . $enemy->name . "\n";
}
?>