<?php

class Position {
    public $x;
    public $y;

    public function __construct($x, $y) {
        $this->x = $x;
        $this->y = $y;
    }
}

class GameObject {
    public $name;
    public $position;

    public function __construct($name, Position $position) {
        $this->name = $name;
        $this->position = $position;
    }
}

class Bullet extends GameObject {
    public $speed;
    public $direction;

    public function __construct($name, Position $position, $speed, Position $direction) {
        parent::__construct($name, $position);
        $this->speed = $speed;
        $this->direction = $direction;
    }

    public function updatePosition() {
        // 更新子弹位置
        $this->position->x += $this->direction->x * $this->speed;
        $this->position->y += $this->direction->y * $this->speed;
    }
}

class Player extends GameObject {
    public function __construct($name, Position $position) {
        parent::__construct($name, $position);
    }
}