function calculateDirection(Position $from, Position $to) {
    $dx = $to->x - $from->x;
    $dy = $to->y - $from->y;
    $length = sqrt($dx * $dx + $dy * $dy);
    return new Position($dx / $length, $dy / $length);
}

function updateBulletDirection(Bullet $bullet, Position $targetPosition, $trackingStrength) {
    // 计算目标方向
    $targetDirection = calculateDirection($bullet->position, $targetPosition);

    // 逐渐调整子弹方向
    $bullet->direction->x += ($targetDirection->x - $bullet->direction->x) * $trackingStrength;
    $bullet->direction->y += ($targetDirection->y - $bullet->direction->y) * $trackingStrength;

    // 归一化方向向量
    $length = sqrt($bullet->direction->x * $bullet->direction->x + $bullet->direction->y * $bullet->direction->y);
    $bullet->direction->x /= $length;
    $bullet->direction->y /= $length;
}